"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[388],{3596:(e,n,s)=>{s.r(n),s.d(n,{assets:()=>a,contentTitle:()=>l,default:()=>d,frontMatter:()=>r,metadata:()=>i,toc:()=>c});const i=JSON.parse('{"id":"wsh","title":"wsh overview","description":"The wsh command provides Wave Terminal\'s core command line interface, allowing users to interact with both terminal and graphical elements from the command line. This guide covers the basics of using wsh and its key features.","source":"@site/docs/wsh.mdx","sourceDirName":".","slug":"/wsh","permalink":"/docsite/wsh","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":4,"frontMatter":{"sidebar_position":4,"id":"wsh","title":"wsh overview"},"sidebar":"defaultSidebar","previous":{"title":"AI Presets","permalink":"/docsite/ai-presets"},"next":{"title":"wsh reference","permalink":"/docsite/wsh-reference"}}');var t=s(2540),o=s(3023);const r={sidebar_position:4,id:"wsh",title:"wsh overview"},l=void 0,a={},c=[{value:"Overview",id:"overview",level:2},{value:"Key Concepts",id:"key-concepts",level:2},{value:"Interacting with Blocks",id:"interacting-with-blocks",level:3},{value:"Persistent State",id:"persistent-state",level:3},{value:"Block Management",id:"block-management",level:3},{value:"Common Workflows",id:"common-workflows",level:2},{value:"Development Workflow",id:"development-workflow",level:3},{value:"Remote Development",id:"remote-development",level:3},{value:"AI-Assisted Development",id:"ai-assisted-development",level:3},{value:"Tips &amp; Features",id:"tips--features",level:2},{value:"Scripting with wsh",id:"scripting-with-wsh",level:2},{value:"Getting Help",id:"getting-help",level:2}];function h(e){const n={a:"a",code:"code",h2:"h2",h3:"h3",li:"li",ol:"ol",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,o.R)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"wsh"})," command provides Wave Terminal's core command line interface, allowing users to interact with both terminal and graphical elements from the command line. This guide covers the basics of using ",(0,t.jsx)(n.code,{children:"wsh"})," and its key features."]}),"\n",(0,t.jsxs)(n.p,{children:["See the ",(0,t.jsx)(n.a,{href:"/wsh-reference",children:"wsh reference"})," for a list of all wsh commands and their arguments."]}),"\n",(0,t.jsx)(n.h2,{id:"overview",children:"Overview"}),"\n",(0,t.jsxs)(n.p,{children:["At its core, ",(0,t.jsx)(n.code,{children:"wsh"})," enables seamless interaction between your terminal commands and Wave's graphical blocks. It allows you to:"]}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsx)(n.li,{children:"Control graphical widgets directly from the command line"}),"\n",(0,t.jsx)(n.li,{children:"Share data between terminal sessions and GUI components"}),"\n",(0,t.jsx)(n.li,{children:"Manage your workspace programmatically"}),"\n",(0,t.jsx)(n.li,{children:"Connect remote and local environments"}),"\n",(0,t.jsx)(n.li,{children:"Send CLI output and files directly to AI conversations"}),"\n",(0,t.jsx)(n.li,{children:"Run terminal commands in separate, isolated blocks"}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"key-concepts",children:"Key Concepts"}),"\n",(0,t.jsx)(n.h3,{id:"interacting-with-blocks",children:"Interacting with Blocks"}),"\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"wsh"})," provides direct interaction with Wave's graphical blocks through the command line. For example:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'# Open a file in the editor\nwsh edit config.json\n\n# Get the current file path from a preview block\nwsh getmeta -b 2 file\n\n# Send output to an AI assistant (the "-" reads from stdin)\nls -la | wsh ai - "what are the largest files here?"\n'})}),"\n",(0,t.jsx)(n.h3,{id:"persistent-state",children:"Persistent State"}),"\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"wsh"})," can maintain state across terminal sessions through its variable and file storage system:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'# Store a variable that persists across sessions\nwsh setvar API_KEY=abc123\n\n# Store globally\nwsh setvar DEPLOY_ENV=prod\n# Or store in the current workspace\nwsh setvar -b workspace DEPLOY_ENV=staging\n\n# Use stored variables in commands\ncurl -H "Authorization: $(wsh getvar API_KEY)" https://api.example.com\n\n# Store a file that can be accessed from any block\necho "data" | wsh file write wavefile://global/config.txt\n\n# Append logs from multiple terminals\necho "Terminal 1 log" | wsh file append wavefile://workspace/logs.txt\n'})}),"\n",(0,t.jsx)(n.h3,{id:"block-management",children:"Block Management"}),"\n",(0,t.jsxs)(n.p,{children:["Every visual element in Wave is a block, and ",(0,t.jsx)(n.code,{children:"wsh"})," gives you complete control over them (hold Ctrl+Shift to see block numbers):"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'# Create a new block showing a webpage\nwsh web open github.com\n\n# Do a web search in a new block\nwsh web open "wave terminal"\n\n# Run a command in a new block and auto-close when done\nwsh run -x -- npm test\n\n# Get information about the current block\nwsh getmeta\n'})}),"\n",(0,t.jsx)(n.h2,{id:"common-workflows",children:"Common Workflows"}),"\n",(0,t.jsxs)(n.p,{children:["Here are some common ways to use ",(0,t.jsx)(n.code,{children:"wsh"}),":"]}),"\n",(0,t.jsx)(n.h3,{id:"development-workflow",children:"Development Workflow"}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'# Open directory or markdown files\nwsh view .\nwsh view README.md\n\n# add a -m to open the block in "magnified" mode\nwsh view -m README.md\n\n# Start development server in a new block (-m will magnify the block on startup)\nwsh run -m -- npm run dev\n\n# Open documentation in a web block\nwsh web open http://localhost:3000\n'})}),"\n",(0,t.jsx)(n.h3,{id:"remote-development",children:"Remote Development"}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:"# Connect to remote server with optional key\nwsh ssh -i ~/.ssh/mykey.pem dev@server\n\n# Edit remote files\nwsh edit /etc/nginx/nginx.conf\n\n# Monitor remote logs\nwsh run -- tail -f /var/log/app.log\n\n# Share variables between sessions\nwsh setvar -b tab SHARED_ENV=staging\n"})}),"\n",(0,t.jsx)(n.h3,{id:"ai-assisted-development",children:"AI-Assisted Development"}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'# Get AI help with code (uses "-" to read from stdin)\ngit diff | wsh ai - "review these changes"\n\n# Get help with a file\nwsh ai -f .zshrc "help me add ~/bin to my path"\n\n# Debug issues (uses "-" to read from stdin)\ndmesg | wsh ai - "help me understand these errors"\n'})}),"\n",(0,t.jsx)(n.h2,{id:"tips--features",children:"Tips & Features"}),"\n",(0,t.jsxs)(n.ol,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.strong,{children:"Working with Blocks"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsx)(n.li,{children:"Use block numbers (1-9) to target specific blocks within a tab (hold Ctrl+Shift to see block numbers)"}),"\n",(0,t.jsx)(n.li,{children:'Can get full block ids by right click a block\'s header and selecting "Copy Block Id" (useful for scripting)'}),"\n",(0,t.jsx)(n.li,{children:'Use references like "this", "tab", "workspace", or "global" for different scopes'}),"\n"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.strong,{children:"Data Storage"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["Use ",(0,t.jsx)(n.code,{children:"wsh setvar/getvar"})," for configuration and secrets"]}),"\n",(0,t.jsxs)(n.li,{children:["Store file data using ",(0,t.jsx)(n.code,{children:"wsh file"}),", which can be easily referenced in all terminals (local and remote)"]}),"\n",(0,t.jsx)(n.li,{children:"Use appropriate storage scopes (block, tab, workspace, global)"}),"\n"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.strong,{children:"Command Execution"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["Use ",(0,t.jsx)(n.code,{children:"wsh run"})," to execute commands in new blocks"]}),"\n",(0,t.jsxs)(n.li,{children:["Send command output and files quickly to AI blocks with ",(0,t.jsx)(n.code,{children:"wsh ai"})]}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"scripting-with-wsh",children:"Scripting with wsh"}),"\n",(0,t.jsxs)(n.p,{children:["wsh commands can be combined in scripts to automate common tasks. Here's an example that sets up a development environment and uses ",(0,t.jsx)(n.code,{children:"wsh notify"})," to monitor a long-running build:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-bash",children:'#!/bin/bash\n# Setup development environment\nwsh run -- docker-compose up -d\nwsh web open localhost:8080\nwsh view ./src\nwsh run -- npm run test:watch\n\n# Get notified when long-running tasks complete using wsh notify\nnpm run build && wsh notify "Build complete" || wsh notify "Build failed"\n'})}),"\n",(0,t.jsx)(n.h2,{id:"getting-help",children:"Getting Help"}),"\n",(0,t.jsxs)(n.p,{children:["You can get help on available commands by running ",(0,t.jsx)(n.code,{children:"wsh"})," with no arguments, or get detailed help for a specific command using ",(0,t.jsx)(n.code,{children:"wsh [command] -h"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["For a complete reference of all ",(0,t.jsx)(n.code,{children:"wsh"})," functionality, see the ",(0,t.jsx)(n.a,{href:"./wsh-reference",children:"WSH Command Reference"}),"."]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{})})]})}function d(e={}){const{wrapper:n}={...(0,o.R)(),...e.components};return n?(0,t.jsx)(n,{...e,children:(0,t.jsx)(h,{...e})}):h(e)}},3023:(e,n,s)=>{s.d(n,{R:()=>r,x:()=>l});var i=s(3696);const t={},o=i.createContext(t);function r(e){const n=i.useContext(o);return i.useMemo((function(){return"function"==typeof e?e(n):{...n,...e}}),[n,e])}function l(e){let n;return n=e.disableParentContext?"function"==typeof e.components?e.components(t):e.components||t:r(e.components),i.createElement(o.Provider,{value:n},e.children)}}}]);