"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[515],{7504:(e,n,s)=>{s.r(n),s.d(n,{assets:()=>o,contentTitle:()=>l,default:()=>h,frontMatter:()=>d,metadata:()=>r,toc:()=>a});const r=JSON.parse('{"id":"presets","title":"Presets","description":"Wave\'s preset system allows you to save and apply multiple configuration settings at once. Presets can be used in two different scenarios:","source":"@site/docs/presets.mdx","sourceDirName":".","slug":"/presets","permalink":"/docsite/presets","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":3.5,"frontMatter":{"sidebar_position":3.5,"id":"presets","title":"Presets"},"sidebar":"defaultSidebar","previous":{"title":"Configuration","permalink":"/docsite/config"},"next":{"title":"AI Presets","permalink":"/docsite/ai-presets"}}');var i=s(2540),t=s(3023);const d={sidebar_position:3.5,id:"presets",title:"Presets"},l="Presets",o={},a=[{value:"Managing Presets",id:"managing-presets",level:2},{value:"File Format",id:"file-format",level:2},{value:"Common Keys",id:"common-keys",level:3},{value:"AI Presets",id:"ai-presets",level:2},{value:"Background Presets",id:"background-presets",level:2},{value:"Configuration Keys",id:"configuration-keys",level:3},{value:"Examples",id:"examples",level:3},{value:"Simple solid color:",id:"simple-solid-color",level:4},{value:"Complex gradient:",id:"complex-gradient",level:4},{value:"Background image:",id:"background-image",level:4}];function c(e){const n={a:"a",admonition:"admonition",code:"code",h1:"h1",h2:"h2",h3:"h3",h4:"h4",header:"header",li:"li",p:"p",pre:"pre",table:"table",tbody:"tbody",td:"td",th:"th",thead:"thead",tr:"tr",ul:"ul",...(0,t.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(n.header,{children:(0,i.jsx)(n.h1,{id:"presets",children:"Presets"})}),"\n",(0,i.jsx)(n.p,{children:"Wave's preset system allows you to save and apply multiple configuration settings at once. Presets can be used in two different scenarios:"}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:["AI models: Configure different AI providers and models (see ",(0,i.jsx)(n.a,{href:"/ai-presets",children:"AI Presets"}),")"]}),"\n",(0,i.jsx)(n.li,{children:"Tab backgrounds: Apply visual styles to your tabs"}),"\n"]}),"\n",(0,i.jsx)(n.h2,{id:"managing-presets",children:"Managing Presets"}),"\n",(0,i.jsx)(n.p,{children:"You can store presets in two locations:"}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"~/.config/waveterm/presets.json"}),": Main presets file"]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"~/.config/waveterm/presets/"}),": Directory for organizing presets into separate files"]}),"\n"]}),"\n",(0,i.jsxs)(n.p,{children:["All presets are aggregated regardless of which file they're in, so you can use the ",(0,i.jsx)(n.code,{children:"presets"})," directory to organize them (e.g., ",(0,i.jsx)(n.code,{children:"presets/bg.json"}),", ",(0,i.jsx)(n.code,{children:"presets/ai.json"}),")."]}),"\n",(0,i.jsxs)(n.admonition,{type:"info",children:[(0,i.jsx)(n.p,{children:"You can easily edit your presets using the built-in editor:"}),(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-bash",children:"wsh editconfig presets.json        # Edit main presets file\nwsh editconfig presets/ai.json     # Edit AI presets\n"})})]}),"\n",(0,i.jsx)(n.h2,{id:"file-format",children:"File Format"}),"\n",(0,i.jsx)(n.p,{children:"Presets follow this format:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'{\n  "<preset-type>@<preset-key>": {\n    "display:name": "<Preset name>",\n    "display:order": "<number>", // optional\n    "<overridden-config-key-1>": "<overridden-config-value-1>"\n    ...\n  }\n}\n'})}),"\n",(0,i.jsxs)(n.p,{children:["The ",(0,i.jsx)(n.code,{children:"preset-type"})," determines where the preset appears in Wave's interface:"]}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"ai"}),': Appears in the models dropdown in the "Wave AI" widget header (see ',(0,i.jsx)(n.a,{href:"/ai-presets",children:"AI Presets"}),")"]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"bg"}),': Appears in the "Backgrounds" submenu when right-clicking a tab']}),"\n"]}),"\n",(0,i.jsx)(n.h3,{id:"common-keys",children:"Common Keys"}),"\n",(0,i.jsxs)(n.table,{children:[(0,i.jsx)(n.thead,{children:(0,i.jsxs)(n.tr,{children:[(0,i.jsx)(n.th,{children:"Key Name"}),(0,i.jsx)(n.th,{children:"Type"}),(0,i.jsx)(n.th,{children:"Function"})]})}),(0,i.jsxs)(n.tbody,{children:[(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["display",":name"]}),(0,i.jsx)(n.td,{children:"string"}),(0,i.jsx)(n.td,{children:"Name shown in the UI menu (required)"})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["display",":order"]}),(0,i.jsx)(n.td,{children:"float"}),(0,i.jsx)(n.td,{children:"Controls the order in the menu (optional)"})]})]})]}),"\n",(0,i.jsx)(n.admonition,{type:"info",children:(0,i.jsxs)(n.p,{children:["When a preset is applied, it overrides the default configuration values for that tab or block. Using ",(0,i.jsx)(n.code,{children:"bg:*"})," or ",(0,i.jsx)(n.code,{children:"ai:*"})," will clear any previously overridden values, setting them back to defaults. It's recommended to include these keys in your presets to ensure a clean slate."]})}),"\n",(0,i.jsx)(n.h2,{id:"ai-presets",children:"AI Presets"}),"\n",(0,i.jsxs)(n.p,{children:["For configuring AI providers and models, see our dedicated ",(0,i.jsx)(n.a,{href:"/ai-presets",children:"AI Presets"})," documentation. It covers setting up presets for:"]}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsx)(n.li,{children:"Local LLMs via Ollama"}),"\n",(0,i.jsx)(n.li,{children:"Azure OpenAI"}),"\n",(0,i.jsx)(n.li,{children:"Anthropic's Claude"}),"\n",(0,i.jsx)(n.li,{children:"Perplexity"}),"\n",(0,i.jsx)(n.li,{children:"And more"}),"\n"]}),"\n",(0,i.jsx)(n.h2,{id:"background-presets",children:"Background Presets"}),"\n",(0,i.jsx)(n.p,{children:'Wave\'s background system harnesses the full power of CSS backgrounds, letting you create rich visual effects through the "background" attribute. You can apply solid colors, gradients (both linear and radial), images, and even blend multiple elements together.'}),"\n",(0,i.jsx)(n.h3,{id:"configuration-keys",children:"Configuration Keys"}),"\n",(0,i.jsxs)(n.table,{children:[(0,i.jsx)(n.thead,{children:(0,i.jsxs)(n.tr,{children:[(0,i.jsx)(n.th,{children:"Key Name"}),(0,i.jsx)(n.th,{children:"Type"}),(0,i.jsx)(n.th,{children:"Function"})]})}),(0,i.jsxs)(n.tbody,{children:[(0,i.jsxs)(n.tr,{children:[(0,i.jsx)(n.td,{children:"bg:*"}),(0,i.jsx)(n.td,{children:"bool"}),(0,i.jsx)(n.td,{children:"Reset all existing bg keys (recommended to prevent any existing background settings from carrying over)"})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsx)(n.td,{children:"bg"}),(0,i.jsx)(n.td,{children:"string"}),(0,i.jsxs)(n.td,{children:["CSS ",(0,i.jsx)(n.code,{children:"background"})," attribute for the tab (supports colors, gradients images, etc.)"]})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["bg",":opacity"]}),(0,i.jsx)(n.td,{children:"float"}),(0,i.jsx)(n.td,{children:"The opacity of the background (defaults to 0.5)"})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["bg",":blendmode"]}),(0,i.jsx)(n.td,{children:"string"}),(0,i.jsxs)(n.td,{children:["The ",(0,i.jsx)(n.a,{href:"https://developer.mozilla.org/en-US/docs/Web/CSS/blend-mode",children:"blend mode"})," of the background"]})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["bg",":bordercolor"]}),(0,i.jsx)(n.td,{children:"string"}),(0,i.jsx)(n.td,{children:"The color of the border when a block is not active (rarely used)"})]}),(0,i.jsxs)(n.tr,{children:[(0,i.jsxs)(n.td,{children:["bg",":activebordercolor"]}),(0,i.jsx)(n.td,{children:"string"}),(0,i.jsx)(n.td,{children:"The color of the border when a block is active"})]})]})]}),"\n",(0,i.jsx)(n.h3,{id:"examples",children:"Examples"}),"\n",(0,i.jsx)(n.h4,{id:"simple-solid-color",children:"Simple solid color:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'{\n  "bg@blue": {\n    "display:name": "Blue",\n    "bg:*": true,\n    "bg": "blue",\n    "bg:opacity": 0.3,\n    "bg:activebordercolor": "rgba(0, 0, 255, 1.0)"\n  }\n}\n'})}),"\n",(0,i.jsx)(n.h4,{id:"complex-gradient",children:"Complex gradient:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'{\n  "bg@duskhorizon": {\n    "display:name": "Dusk Horizon",\n    "bg:*": true,\n    "bg": "linear-gradient(0deg, rgba(128,0,0,1) 0%, rgba(204,85,0,0.7) 20%, rgba(255,140,0,0.6) 45%, rgba(160,90,160,0.5) 65%, rgba(60,60,120,1) 100%), radial-gradient(circle at 30% 30%, rgba(255,255,255,0.1), transparent 60%), radial-gradient(circle at 70% 70%, rgba(255,255,255,0.05), transparent 70%)",\n    "bg:opacity": 0.9,\n    "bg:blendmode": "overlay"\n  }\n}\n'})}),"\n",(0,i.jsx)(n.h4,{id:"background-image",children:"Background image:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'{\n  "bg@ocean": {\n    "display:name": "Ocean Scene",\n    "bg:*": true,\n    "bg": "url(\'/path/to/ocean.jpg\') center/cover no-repeat",\n    "bg:opacity": 0.2\n  }\n}\n'})}),"\n",(0,i.jsx)(n.admonition,{type:"info",children:(0,i.jsxs)(n.p,{children:["Background images support both URLs and local file paths. For better reliability, we recommend using local files. Local paths must be absolute or start with ",(0,i.jsx)(n.code,{children:"~"})," (e.g., ",(0,i.jsx)(n.code,{children:"~/Downloads/background.png"}),"). We support common web formats: PNG, JPEG/JPG, WebP, GIF, and SVG."]})}),"\n",(0,i.jsxs)(n.admonition,{type:"tip",children:[(0,i.jsxs)(n.p,{children:["The ",(0,i.jsx)(n.code,{children:"setbg"})," command can help generate background preset JSON:"]}),(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-bash",children:'# Preview a solid color preset\nwsh setbg --print "#ff0000"\n{\n  "bg:*": true,\n  "bg": "#ff0000",\n  "bg:opacity": 0.5\n}\n\n# Preview a centered image preset\nwsh setbg --print --center --opacity 0.3 ~/logo.png\n{\n  "bg:*": true,\n  "bg": "url(\'/absolute/path/to/logo.png\') no-repeat center/auto",\n  "bg:opacity": 0.3\n}\n'})}),(0,i.jsxs)(n.p,{children:["Just add the required ",(0,i.jsx)(n.code,{children:"display:name"})," field to complete your preset!"]})]})]})}function h(e={}){const{wrapper:n}={...(0,t.R)(),...e.components};return n?(0,i.jsx)(n,{...e,children:(0,i.jsx)(c,{...e})}):c(e)}},3023:(e,n,s)=>{s.d(n,{R:()=>d,x:()=>l});var r=s(3696);const i={},t=r.createContext(i);function d(e){const n=r.useContext(t);return r.useMemo((function(){return"function"==typeof e?e(n):{...n,...e}}),[n,e])}function l(e){let n;return n=e.disableParentContext?"function"==typeof e.components?e.components(i):e.components||i:d(e.components),r.createElement(t.Provider,{value:n},e.children)}}}]);