"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[569],{1373:(e,n,i)=>{i.r(n),i.d(n,{assets:()=>t,contentTitle:()=>r,default:()=>p,frontMatter:()=>o,metadata:()=>a,toc:()=>d});const a=JSON.parse('{"id":"ai-presets","title":"AI Presets","description":"AI Presets Menu","source":"@site/docs/ai-presets.mdx","sourceDirName":".","slug":"/ai-presets","permalink":"/docsite/ai-presets","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":3.6,"frontMatter":{"sidebar_position":3.6,"id":"ai-presets","title":"AI Presets"},"sidebar":"defaultSidebar","previous":{"title":"Presets","permalink":"/docsite/presets"},"next":{"title":"wsh overview","permalink":"/docsite/wsh"}}');var s=i(2540),l=i(3023);const o={sidebar_position:3.6,id:"ai-presets",title:"AI Presets"},r=void 0,t={},d=[{value:"How AI Presets Work",id:"how-ai-presets-work",level:2},{value:"Provider-Specific Configurations",id:"provider-specific-configurations",level:2},{value:"Anthropic (Claude)",id:"anthropic-claude",level:3},{value:"Local LLMs (Ollama)",id:"local-llms-ollama",level:3},{value:"Azure OpenAI",id:"azure-openai",level:3},{value:"Perplexity",id:"perplexity",level:3},{value:"Google (Gemini)",id:"google-gemini",level:3},{value:"Multiple Presets Example",id:"multiple-presets-example",level:2}];function c(e){const n={a:"a",admonition:"admonition",code:"code",h2:"h2",h3:"h3",img:"img",p:"p",pre:"pre",...(0,l.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(n.p,{children:(0,s.jsx)(n.img,{alt:"AI Presets Menu",src:i(6633).A+"#right",width:"638",height:"466"})}),"\n",(0,s.jsx)(n.p,{children:"Wave's AI widget can be configured to work with various AI providers and models through presets. Presets allow you to define multiple AI configurations and easily switch between them using the dropdown menu in the AI widget."}),"\n",(0,s.jsx)(n.h2,{id:"how-ai-presets-work",children:"How AI Presets Work"}),"\n",(0,s.jsxs)(n.p,{children:["AI presets are defined in ",(0,s.jsx)(n.code,{children:"~/.config/waveterm/presets/ai.json"}),". You can easily edit this file using:"]}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-bash",children:"wsh editconfig presets/ai.json\n"})}),"\n",(0,s.jsxs)(n.p,{children:["Each preset defines a complete set of configuration values for the AI widget. When you select a preset from the dropdown menu, those configuration values are applied to the widget. If no preset is selected, the widget uses the default values from ",(0,s.jsx)(n.code,{children:"settings.json"}),"."]}),"\n",(0,s.jsx)(n.p,{children:"Here's a basic example using Claude:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@claude-sonnet": {\n    "display:name": "Claude 3 Sonnet",\n    "display:order": 1,\n    "ai:*": true,\n    "ai:apitype": "anthropic",\n    "ai:model": "claude-3-5-sonnet-latest",\n    "ai:apitoken": "<your anthropic API key>"\n  }\n}\n'})}),"\n",(0,s.jsxs)(n.p,{children:["To make a preset your default, add this single line to your ",(0,s.jsx)(n.code,{children:"settings.json"}),":"]}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai:preset": "ai@claude-sonnet"\n}\n'})}),"\n",(0,s.jsxs)(n.admonition,{type:"info",children:[(0,s.jsxs)(n.p,{children:["You can quickly set your default preset using the ",(0,s.jsx)(n.code,{children:"setconfig"})," command:"]}),(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-bash",children:"wsh setconfig ai:preset=ai@claude-sonnet\n"})}),(0,s.jsx)(n.p,{children:"This is easier than editing settings.json directly!"})]}),"\n",(0,s.jsx)(n.h2,{id:"provider-specific-configurations",children:"Provider-Specific Configurations"}),"\n",(0,s.jsx)(n.h3,{id:"anthropic-claude",children:"Anthropic (Claude)"}),"\n",(0,s.jsx)(n.p,{children:"To use Claude models, create a preset like this:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@claude-sonnet": {\n    "display:name": "Claude 3 Sonnet",\n    "display:order": 1,\n    "ai:*": true,\n    "ai:apitype": "anthropic",\n    "ai:model": "claude-3-5-sonnet-latest",\n    "ai:apitoken": "<your anthropic API key>"\n  }\n}\n'})}),"\n",(0,s.jsx)(n.h3,{id:"local-llms-ollama",children:"Local LLMs (Ollama)"}),"\n",(0,s.jsx)(n.p,{children:"To connect to a local Ollama instance:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@ollama-llama": {\n    "display:name": "Ollama - Llama2",\n    "display:order": 2,\n    "ai:*": true,\n    "ai:baseurl": "http://localhost:11434/v1",\n    "ai:name": "llama2",\n    "ai:model": "llama2",\n    "ai:apitoken": "ollama"\n  }\n}\n'})}),"\n",(0,s.jsxs)(n.p,{children:["Note: The ",(0,s.jsx)(n.code,{children:"ai:apitoken"})," is required but can be any value as Ollama ignores it. See ",(0,s.jsx)(n.a,{href:"https://github.com/ollama/ollama/blob/main/docs/openai.md",children:"Ollama OpenAI compatibility docs"})," for more details."]}),"\n",(0,s.jsx)(n.h3,{id:"azure-openai",children:"Azure OpenAI"}),"\n",(0,s.jsx)(n.p,{children:"To connect to Azure AI services:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@azure-gpt4": {\n    "display:name": "Azure GPT-4",\n    "display:order": 3,\n    "ai:*": true,\n    "ai:apitype": "azure",\n    "ai:baseurl": "<your Azure AI base URL>",\n    "ai:model": "<your model deployment name>",\n    "ai:apitoken": "<your Azure API key>"\n  }\n}\n'})}),"\n",(0,s.jsxs)(n.p,{children:["Note: Do not include query parameters or ",(0,s.jsx)(n.code,{children:"api-version"})," in the ",(0,s.jsx)(n.code,{children:"ai:baseurl"}),". The ",(0,s.jsx)(n.code,{children:"ai:model"})," should be your model deployment name in Azure."]}),"\n",(0,s.jsx)(n.h3,{id:"perplexity",children:"Perplexity"}),"\n",(0,s.jsx)(n.p,{children:"To use Perplexity's models:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@perplexity-sonar": {\n    "display:name": "Perplexity Sonar",\n    "display:order": 4,\n    "ai:*": true,\n    "ai:apitype": "perplexity",\n    "ai:model": "llama-3.1-sonar-small-128k-online",\n    "ai:apitoken": "<your perplexity API key>"\n  }\n}\n'})}),"\n",(0,s.jsx)(n.h3,{id:"google-gemini",children:"Google (Gemini)"}),"\n",(0,s.jsxs)(n.p,{children:["To use Google's Gemini models from ",(0,s.jsx)(n.a,{href:"https://aistudio.google.com",children:"Google AI Studio"}),":"]}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@gemini-2.0": {\n    "display:name": "Gemini 2.0",\n    "display:order": 5,\n    "ai:*": true,\n    "ai:apitype": "google",\n    "ai:model": "gemini-2.0-flash-exp",\n    "ai:apitoken": "<your Google AI API key>"\n  }\n}\n'})}),"\n",(0,s.jsx)(n.h2,{id:"multiple-presets-example",children:"Multiple Presets Example"}),"\n",(0,s.jsxs)(n.p,{children:["You can define multiple presets in your ",(0,s.jsx)(n.code,{children:"ai.json"})," file:"]}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai@claude-sonnet": {\n    "display:name": "Claude 3 Sonnet",\n    "display:order": 1,\n    "ai:*": true,\n    "ai:apitype": "anthropic",\n    "ai:model": "claude-3-5-sonnet-latest",\n    "ai:apitoken": "<your anthropic API key>"\n  },\n  "ai@ollama-llama": {\n    "display:name": "Ollama - Llama2",\n    "display:order": 2,\n    "ai:*": true,\n    "ai:baseurl": "http://localhost:11434/v1",\n    "ai:name": "llama2",\n    "ai:model": "llama2",\n    "ai:apitoken": "ollama"\n  },\n  "ai@perplexity-sonar": {\n    "display:name": "Perplexity Sonar",\n    "display:order": 3,\n    "ai:*": true,\n    "ai:apitype": "perplexity",\n    "ai:model": "llama-3.1-sonar-small-128k-online",\n    "ai:apitoken": "<your perplexity API key>"\n  }\n}\n'})}),"\n",(0,s.jsxs)(n.p,{children:["The ",(0,s.jsx)(n.code,{children:"display:order"})," value determines the order in which presets appear in the dropdown menu."]}),"\n",(0,s.jsxs)(n.p,{children:["Remember to set your default preset in ",(0,s.jsx)(n.code,{children:"settings.json"}),":"]}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'{\n  "ai:preset": "ai@claude-sonnet"\n}\n'})})]})}function p(e={}){const{wrapper:n}={...(0,l.R)(),...e.components};return n?(0,s.jsx)(n,{...e,children:(0,s.jsx)(c,{...e})}):c(e)}},6633:(e,n,i)=>{i.d(n,{A:()=>a});const a=i.p+"assets/images/ai-presets-049858075b5b6805b80b53a1bdf4f763.png"},3023:(e,n,i)=>{i.d(n,{R:()=>o,x:()=>r});var a=i(3696);const s={},l=a.createContext(s);function o(e){const n=a.useContext(l);return a.useMemo((function(){return"function"==typeof e?e(n):{...n,...e}}),[n,e])}function r(e){let n;return n=e.disableParentContext?"function"==typeof e.components?e.components(s):e.components||s:o(e.components),a.createElement(l.Provider,{value:n},e.children)}}}]);